<?php
	if (!class_exists('TS_TablesWP_Class_Editor')){
		class TS_TablesWP_Class_Editor {
			function __construct() {
                global $TS_ADVANCED_TABLESWP;
                // Load Tables Core Data
                if (!isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables)) {
                    $TS_ADVANCED_TABLESWP->TS_TablesWP_GetTablesCoreData();					
                }
                if (!isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_UsedIDs)) {
                    $TS_ADVANCED_TABLESWP->TS_TablesWP_GetTablesUsedIDs();
                }
				// AJAX Callbacks for Editor Save
				add_action('wp_ajax_ts_tableeditor_save',           array($this, 'TS_TablesWP_Editor_SaveTable'));
                add_action('wp_ajax_nopriv_ts_tableeditor_save',    array($this, 'TS_TablesWP_Editor_SaveTable'));
				add_action('wp_ajax_ts_tableeditor_clone',          array($this, 'TS_TablesWP_Editor_CloneTable'));
                add_action('wp_ajax_nopriv_ts_tableeditor_clone',   array($this, 'TS_TablesWP_Editor_CloneTable'));
				add_action('wp_ajax_ts_tableeditor_delete',         array($this, 'TS_TablesWP_Editor_DeleteTable'));
                add_action('wp_ajax_nopriv_ts_tableeditor_delete',  array($this, 'TS_TablesWP_Editor_DeleteTable'));                
			}
		
			// Function to Save Table Data via AJAX
			// ------------------------------------
			function TS_TablesWP_Editor_SaveTable() {
                global $TS_ADVANCED_TABLESWP;
                global $wpdb;
				$error_pass 					    		        = true;
				$error_code						    		        = array();
				// Default Response Holder
				$form_response                  			        = array(
					'success'                     			        => true,
                    'message'								        => array(),
                    'loadnew'                                       => '',
                    'referrer'                                      => '',
                    'debugging'                                     => '',
				);
				// Check for NONCE Compliance
				if (empty($_POST) || !wp_verify_nonce($_POST['ts-advanced-table-transfer-nonce'], 'ts-advanced-tables')) {				   
				    $error_code['nonce']                            = (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
				    $error_pass                                     = false;			   
                }
                // Retrieve Form Contents
                $TS_TablesWP_Editor_ID          	                = trim ($_POST['ts-advanced-table-number-input']);
                $TS_TablesWP_Editor_ID				                = (string)$TS_TablesWP_Editor_ID;
                $TS_TablesWP_Editor_Name        	                = trim ($_POST['ts-advanced-table-name-input']);
                $TS_TablesWP_Editor_Date        	                = trim ($_POST['ts-advanced-table-date-stamp']);	
                $TS_TablesWP_Editor_Rows      		                = trim ($_POST['ts-advanced-table-transfer-rows']);
                $TS_TablesWP_Editor_Columns			                = trim ($_POST['ts-advanced-table-transfer-columns']);
                $TS_TablesWP_Editor_Merged      	                = trim ($_POST['ts-advanced-table-transfer-merged']);		
                $TS_TablesWP_Editor_Info        	                = trim ($_POST['ts-advanced-table-info-input']);
                $TS_TablesWP_Editor_Defaults		                = trim ($_POST['ts-advanced-table-transfer-defaults']);
                $TS_TablesWP_Editor_Data			                = trim ($_POST['ts-advanced-table-transfer-data']);
                $TS_TablesWP_Editor_Meta			                = trim ($_POST['ts-advanced-table-transfer-meta']);
                $TS_TablesWP_Editor_Other			                = trim ($_POST['ts-advanced-table-transfer-other']);
                $TS_TablesWP_Editor_Cats			                = trim ($_POST['ts-advanced-table-transfer-cats']);
                $TS_TablesWP_Editor_Tags			                = trim ($_POST['ts-advanced-table-transfer-tags']);
                // Check for New or Existing Table
                $TS_TablesWP_Editor_BaseName		                = $TS_ADVANCED_TABLESWP->TS_TablesWP_PluginMYSQL;
                $TS_TablesWP_Editor_BaseData		                = $wpdb->get_row("SELECT * FROM $TS_TablesWP_Editor_BaseName WHERE `number` = $TS_TablesWP_Editor_ID");
                if ($TS_TablesWP_Editor_BaseData == null) {
                    $TS_TablesWP_Editor_Validator                   = false;
                } else {
                    $TS_TablesWP_Editor_Validator                   = true;
                }
                if ((!$TS_TablesWP_Editor_Validator) && (isset($_POST['_wp_http_referer'])) && (strpos(trim($_POST['_wp_http_referer']), "page=TS_TablesWP_AddNew") !== false)) {
                    // Add New Table To Database
                    $wpdb->insert($wpdb->prefix . "ts_advancedtables", array(
                        "number"                                    => $TS_TablesWP_Editor_ID,
                        "name"                                      => $TS_TablesWP_Editor_Name,
                        "cols"                                      => $TS_TablesWP_Editor_Columns,
                        "rows"                                      => $TS_TablesWP_Editor_Rows,
                        "created"                                   => date("Y-m-d H:i:s", current_time('timestamp', 0)),
                        "merged"                                    => stripcslashes($TS_TablesWP_Editor_Merged),
                        "defaults"                                  => stripcslashes($TS_TablesWP_Editor_Defaults),
                        "info"                                      => stripcslashes($TS_TablesWP_Editor_Info),
                        "data"                                      => stripcslashes($TS_TablesWP_Editor_Data),
                        "meta"                                      => stripcslashes($TS_TablesWP_Editor_Meta),
                        "other"                                     => stripcslashes($TS_TablesWP_Editor_Other),
                    ));
                    // Add New Table for Basic Listing
                    $TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables["table" . $TS_TablesWP_Editor_ID] = array(
                        "id"                                        => $TS_TablesWP_Editor_ID,
                        "name"                                      => $TS_TablesWP_Editor_Name,
                        "create"                                    => intval($TS_TablesWP_Editor_Date),
                        "update"                                    => intval($TS_TablesWP_Editor_Date),
                        "info"                                      => base64_encode($TS_TablesWP_Editor_Info),			
                        "rows"                                      => $TS_TablesWP_Editor_Rows,
                        "columns"                                   => $TS_TablesWP_Editor_Columns,
                        "merged"                                    => $TS_TablesWP_Editor_Merged,
                        "charts"                                    => "false",
                        "categories"                                => $TS_TablesWP_Editor_Cats,
                        "tags"                                      => $TS_TablesWP_Editor_Tags,
                    );
                    update_option("ts_tablesplus_extend_settings_tables", $TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables);
                    // Update Global Table ID Collector
                    array_push($TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_UsedIDs, $TS_TablesWP_Editor_ID);
                    update_option("ts_tablesplus_extend_settings_usedids", $TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_UsedIDs);
                    $form_response['loadnew']                       = admin_url('admin.php?page=TS_TablesWP_Modify&tableid=' . $TS_TablesWP_Editor_ID . '&action=edit');
                } else {
                    // Update Table In Database
                    $wpdb->update($wpdb->prefix . "ts_advancedtables",
                        array(
                            "name"                                  => $TS_TablesWP_Editor_Name,
                            "cols"                                  => $TS_TablesWP_Editor_Columns,
                            "rows"                                  => $TS_TablesWP_Editor_Rows,
                            "merged"                                => stripcslashes($TS_TablesWP_Editor_Merged),
                            "defaults"                              => stripcslashes($TS_TablesWP_Editor_Defaults),
                            "info"                                  => stripcslashes($TS_TablesWP_Editor_Info),
                            "data"                                  => stripcslashes($TS_TablesWP_Editor_Data),
                            "meta"                                  => stripcslashes($TS_TablesWP_Editor_Meta),
                            "other"                                 => stripcslashes($TS_TablesWP_Editor_Other),			
                        ), array(
                            'number'                                => $TS_TablesWP_Editor_ID
                        ), null, array('%d')
                    );
                    // Update Table In Basic Listing
                    $TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables["table" . $TS_TablesWP_Editor_ID] = array(
                        "id"                                        => $TS_TablesWP_Editor_ID,
                        "name"                                      => $TS_TablesWP_Editor_Name,
                        "create"                                    => intval($TS_TablesWP_Editor_Date),
                        "update"                                    => (int)current_time('timestamp', 0),
                        "info"                                      => base64_encode($TS_TablesWP_Editor_Info),
                        "rows"                                      => $TS_TablesWP_Editor_Rows,
                        "columns"                                   => $TS_TablesWP_Editor_Columns,
                        "merged"                                    => $TS_TablesWP_Editor_Merged,
                        "charts"                                    => "false",
                        "categories"                                => $TS_TablesWP_Editor_Cats,
                        "tags"                                      => $TS_TablesWP_Editor_Tags,
                    );
                    update_option("ts_tablesplus_extend_settings_tables", $TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables);
                }
				// AJAX Return Message
                $form_response['referrer']					        = trim (isset($_POST['_wp_http_referer']) ? $_POST['_wp_http_referer'] : '');
                $form_response['success']					        = $error_pass;
				if ($error_pass) {

				}
				wp_send_json($form_response);
				Exit();
            }
            
			// Function to Clone Table Data via AJAX
			// -------------------------------------
            function TS_TablesWP_Editor_CloneTable() {
                global $TS_ADVANCED_TABLESWP;
                global $wpdb;
				$error_pass 					    		        = true;
				$error_code						    		        = array();
				// Default Response Holder
				$form_response                  			        = array(
					'success'                     			        => true,
                    'message'								        => array(),
                    'referrer'                                      => '',
                    'debugging'                                     => '',
				);
				// Check for NONCE Compliance
				if (empty($_POST) || !wp_verify_nonce($_POST['ts-advanced-table-transfer-nonce'], 'ts-advanced-tables')) {				   
				    $error_code['nonce']                            = (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
				    $error_pass                                     = false;			   
                }
                // AJAX Return Message
                $form_response['referrer']					        = trim (isset($_POST['_wp_http_referer']) ? $_POST['_wp_http_referer'] : '');
				$form_response['success']					        = $error_pass;
				if ($error_pass) {

				}
				wp_send_json($form_response);
				Exit();
            }

			// Function to Delete Table Data via AJAX
			// --------------------------------------
            function TS_TablesWP_Editor_DeleteTable() {
                global $TS_ADVANCED_TABLESWP;
                global $wpdb;
				$error_pass 					    		        = true;
				$error_code						    		        = array();
				// Default Response Holder
				$form_response                  			        = array(
					'success'                     			        => true,
                    'message'								        => array(),
                    'referrer'                                      => '',
                    'debugging'                                     => '',
				);
				// Check for NONCE Compliance
				if (empty($_POST) || !wp_verify_nonce($_POST['ts-advanced-table-transfer-nonce'], 'ts-advanced-tables')) {				   
				    $error_code['nonce']                            = (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
				    $error_pass                                     = false;			   
                }
                // Retrieve Form Contents
                $TS_TablesWP_Editor_ID          	                = trim ($_POST['ts-advanced-table-number-input']);
                $TS_TablesWP_Editor_ID				                = (string)$TS_TablesWP_Editor_ID;
                $TS_TablesWP_Editor_Listing			                = trim ($_POST['ts-advanced-table-transfer-listing']);
                // Remove Table Reference
                unset($TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables['table' . $TS_TablesWP_Editor_ID]);
                update_option("ts_tablesplus_extend_settings_tables", $TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables);
                // Adjust Global Table ID Collector
                unset($TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_UsedIDs[$TS_TablesWP_Editor_ID]);
                update_option("ts_tablesplus_extend_settings_usedids", $TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_UsedIDs);
                // Remove Table from Database
                $wpdb->delete($wpdb->prefix . "ts_advancedtables",
                    array(
                        'number' 					                => $TS_TablesWP_Editor_ID
                    ), array('%d')
                );
                $TS_TablesWP_Editor_Optimize 		                = $wpdb->query("OPTIMIZE TABLE $TS_TablesWP_Editor_Table");
                // AJAX Return Message
                $form_response['referrer']					        = trim (isset($_POST['_wp_http_referer']) ? $_POST['_wp_http_referer'] : '');
				$form_response['success']					        = $error_pass;
				if ($error_pass) {

				}
				wp_send_json($form_response);
                // Redirect to Listing Page       
                echo'<script>window.location="' . $TS_TablesWP_Editor_Listing . '";</script>';
                Exit();
            }
		}
	}
	if (class_exists('TS_TablesWP_Class_Editor')) {
		$TS_TablesWP_Class_Editor = new TS_TablesWP_Class_Editor;
	}
?>