<?php
	if (!class_exists('TS_TablesWP_Class_Settings')){
		class TS_TablesWP_Class_Settings {
			function __construct() {
                global $TS_ADVANCED_TABLESWP;
				// AJAX Callbacks for Settings Save
				add_action('wp_ajax_ts_tablesettings_save',         array($this, 'TS_TablesWP_Settings_Save'));
                add_action('wp_ajax_nopriv_ts_tablesettings_save',  array($this, 'TS_TablesWP_Settings_Save'));
			}
		
			// Function to Save Settings Data via AJAX
			// ---------------------------------------
			function TS_TablesWP_Settings_Save() {
                global $TS_ADVANCED_TABLESWP;
                global $wpdb;
				$error_pass 					    		        = true;
				$error_code						    		        = array();
				// Default Response Holder
				$form_response                  			        = array(
					'success'                     			        => true,
                    'message'								        => array(),
                    'utilizeajax'                                   => true,
                    'settings'                                      => array(),
				);
				// Check for NONCE Compliance
				if (empty($_POST) || !wp_verify_nonce($_POST['ts-advanced-table-settings-nonce'], 'ts-advanced-tables')) {
				    $error_code['nonce']                            = (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
				    $error_pass                                     = false;			   
                }
                // Retrieve Custom Settings
                $TS_TablesWP_Settings_UserDefined                   = array(
                    // General Settings
                    'general'								        => array(
                        'reuseids'              			        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultReuseIDs'])) ? $_POST['ts_vcsc_extend_settings_defaultReuseIDs'] : 0))) == 0 ? false : true),
                        'saveredirect'          			        => false,
                        'utilizeajax'              			        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultUtilizeAJAX'])) ? $_POST['ts_vcsc_extend_settings_defaultUtilizeAJAX'] : 0))) == 0 ? false : true),
                        'mainmenu'              			        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultMainMenu'])) ? $_POST['ts_vcsc_extend_settings_defaultMainMenu'] : 0))) == 0 ? false : true),
                        'initialsort'           			        => trim($_POST['ts_vcsc_extend_settings_defaultInitialSortValue']),
                        'initialorder'						        => trim($_POST['ts_vcsc_extend_settings_defaultInitialOrderValue']),
                        'initialitems'                              => intval(trim($_POST['ts_vcsc_extend_settings_defaultInitialItemsValue'])),
                        'exportlist'						        => false,
                        'exportoptions'						        => 'print,pdf,csv,excel,copy',
                        'loadlanguage'						        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultLoadLanguage'])) ? $_POST['ts_vcsc_extend_settings_defaultLoadLanguage'] : 0))) == 0 ? false : true),
                        'composerintegrate'					        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultComposerIntegrate'])) ? $_POST['ts_vcsc_extend_settings_defaultComposerIntegrate'] : 0))) == 0 ? false : true),
                        'deletetables'						        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultDeleteTables'])) ? $_POST['ts_vcsc_extend_settings_defaultDeleteTables'] : 0))) == 0 ? false : true),
                        'shortcodealways'					        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultShortcodeAlways'])) ? $_POST['ts_vcsc_extend_settings_defaultShortcodeAlways'] : 0))) == 0 ? false : true),
                        'autoupdate'                                => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultAutoUpdate'])) ? $_POST['ts_vcsc_extend_settings_defaultAutoUpdate'] : 0))) == 0 ? false : true),
                        'editoraccess'						        => (trim($_POST['ts_vcsc_extend_settings_defaultUserRolesEditor']) != "" ? "administrator," . trim($_POST['ts_vcsc_extend_settings_defaultUserRolesEditor']) : "administrator"),
                        'removemenu'                                => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultRemoveMenu'])) ? $_POST['ts_vcsc_extend_settings_defaultRemoveMenu'] : 0))) == 0 ? false : true),
                        'jquerymigrate'                             => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultjQueryMigrate'])) ? $_POST['ts_vcsc_extend_settings_defaultjQueryMigrate'] : 0))) == 0 ? false : true),
                    ),
                    // File Loading
                    'filestatus'							        => array(
                        'loadalways'						        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultLoadFilesAlways'])) ? $_POST['ts_vcsc_extend_settings_defaultLoadFilesAlways'] : 0))) == 0 ? false : true),
                        'loadtablesaw'						        => true,
                        'loadfootable'						        => true,
                        'loaddatatable'						        => true,
                        'loadtooltipster'					        => true,
                        'loadhelpers'						        => true,
                        'loaddynamiccss'                            => trim($_POST['ts_vcsc_extend_settings_defaultDynamicLoadValue']),
                    ),
                    // Editors Injection
                    'tinymce'								        => array(
                        'allowinject'						        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultTinyMCEAllow'])) ? $_POST['ts_vcsc_extend_settings_defaultTinyMCEAllow'] : 0))) == 0 ? false : true),
                        'posttypes'							        => trim($_POST['ts_vcsc_extend_settings_defaultTinyMCEPostTypes']),
                    ),
                    // Table Editor
                    'tableeditor'							        => array(
                        'minheight'							        => '200',
                        'maxheight'							        => '800',
                        'locale'							        => trim($_POST['ts_vcsc_extend_settings_defaultEditorLocaleValue']),
                    ),
                    // Cell Content Alignments
                    'alignments'            				        => array(
                        'horizontal'        				        => trim($_POST['ts_vcsc_extend_settings_defaultAlignHorizontalValue']),
                        'vertical'          				        => trim($_POST['ts_vcsc_extend_settings_defaultAlignVerticalValue']),
                    ),
                    // Cell Format Settings
                    'formats'               				        => array(
                        'decimalsNumeric'					        => trim($_POST['ts_vcsc_extend_settings_defaultDecimalsNumeric']),
                        'decimalsCurrency'					        => trim($_POST['ts_vcsc_extend_settings_defaultDecimalsCurrency']),
                        'decimalsPercent'					        => trim($_POST['ts_vcsc_extend_settings_defaultDecimalsPercent']),
                        'currencyPlacement'					        => trim($_POST['ts_vcsc_extend_settings_defaultPlacementCurrencyValue']),
                        'currencySpacer'					        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultCurrencySpacer'])) ? $_POST['ts_vcsc_extend_settings_defaultCurrencySpacer'] : 0))) == 0 ? false : true),
                        'percentSpacer'						        => ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultPercentSpacer'])) ? $_POST['ts_vcsc_extend_settings_defaultPercentSpacer'] : 0))) == 0 ? false : true),
                        'formatDate'						        => trim($_POST['ts_vcsc_extend_settings_defaultFormatDateValue']),
                        'formatTimeHours'					        => trim($_POST['ts_vcsc_extend_settings_defaultFormatTimeHourValue']),
                        'formatTimeMinutes'					        => trim($_POST['ts_vcsc_extend_settings_defaultFormatTimeMinuteValue']),
                        'formatTimeSeconds'					        => trim($_POST['ts_vcsc_extend_settings_defaultFormatTimeSecondValue']),
                        'formatTimeMeridiem'				        => 'A',
                    ),
                    // Breakpoint Settings
                    'breakpoints'							        => array(
                        'footableLarge'						        => trim($_POST['ts_vcsc_extend_settings_defaultFootableLarge']),
                        'footableMedium'					        => trim($_POST['ts_vcsc_extend_settings_defaultFootableMedium']),
                        'footableSmall'						        => trim($_POST['ts_vcsc_extend_settings_defaultFootableSmall']),
                        'footableTiny'						        => trim($_POST['ts_vcsc_extend_settings_defaultFootableTiny']),
                        'datatableDesktop'					        => 'Infinity',
                        'datatableTabletL'					        => trim($_POST['ts_vcsc_extend_settings_defaultDatatableTabletL']),
                        'datatableTabletP'					        => trim($_POST['ts_vcsc_extend_settings_defaultDatatableTabletP']),
                        'datatableMobileL'					        => trim($_POST['ts_vcsc_extend_settings_defaultDatatableMobileL']),
                        'datatableMobileP'					        => trim($_POST['ts_vcsc_extend_settings_defaultDatatableMobileP']),
                    ),
                    // Icon Font Settings
                    'fontmanager'							        => array(
                        'internalAwesome'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalAwesome'])) ? $_POST['ts_vcsc_extend_tinymce_internalAwesome'] : 0))) == 0 ? false : true),
                        'internalBrankic'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalBrankic'])) ? $_POST['ts_vcsc_extend_tinymce_internalBrankic'] : 0))) == 0 ? false : true),
                        'internalCountricons'				        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalCountricons'])) ? $_POST['ts_vcsc_extend_tinymce_internalCountricons'] : 0))) == 0 ? false : true),
                        'internalCurrencies'				        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalCurrencies'])) ? $_POST['ts_vcsc_extend_tinymce_internalCurrencies'] : 0))) == 0 ? false : true),
                        'internalElegant'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalElegant'])) ? $_POST['ts_vcsc_extend_tinymce_internalElegant'] : 0))) == 0 ? false : true),
                        'internalEntypo'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalEntypo'])) ? $_POST['ts_vcsc_extend_tinymce_internalEntypo'] : 0))) == 0 ? false : true),
                        'internalFoundation'				        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalFoundation'])) ? $_POST['ts_vcsc_extend_tinymce_internalFoundation'] : 0))) == 0 ? false : true),
                        'internalGenericons'				        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalGenericons'])) ? $_POST['ts_vcsc_extend_tinymce_internalGenericons'] : 0))) == 0 ? false : true),
                        'internalIcoMoon'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalIcoMoon'])) ? $_POST['ts_vcsc_extend_tinymce_internalIcoMoon'] : 0))) == 0 ? false : true),
                        'internalIonicons'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalIonicons'])) ? $_POST['ts_vcsc_extend_tinymce_internalIonicons'] : 0))) == 0 ? false : true),
                        'internalMapIcons'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalMapIcons'])) ? $_POST['ts_vcsc_extend_tinymce_internalMapIcons'] : 0))) == 0 ? false : true),
                        'internalMetrize'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalMetrize'])) ? $_POST['ts_vcsc_extend_tinymce_internalMetrize'] : 0))) == 0 ? false : true),
                        'internalMonuments'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalMonuments'])) ? $_POST['ts_vcsc_extend_tinymce_internalMonuments'] : 0))) == 0 ? false : true),
                        'internalSocialMedia'				        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalSocialMedia'])) ? $_POST['ts_vcsc_extend_tinymce_internalSocialMedia'] : 0))) == 0 ? false : true),
                        'internalThemify'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalThemify'])) ? $_POST['ts_vcsc_extend_tinymce_internalThemify'] : 0))) == 0 ? false : true),
                        'internalTypicons'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalTypicons'])) ? $_POST['ts_vcsc_extend_tinymce_internalTypicons'] : 0))) == 0 ? false : true),				
                        'internalCustom'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalCustom'])) ? $_POST['ts_vcsc_extend_tinymce_internalCustom'] : 0))) == 0 ? false : true),
                        'internalDashicons'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_internalDashicons'])) ? $_POST['ts_vcsc_extend_tinymce_internalDashicons'] : 0))) == 0 ? false : true),
                        'composerAwesome'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_composerAwesome'])) ? $_POST['ts_vcsc_extend_tinymce_composerAwesome'] : 0))) == 0 ? false : true),
                        'composerEntypo'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_composerEntypo'])) ? $_POST['ts_vcsc_extend_tinymce_composerEntypo'] : 0))) == 0 ? false : true),
                        'composerLinecons'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_composerLinecons'])) ? $_POST['ts_vcsc_extend_tinymce_composerLinecons'] : 0))) == 0 ? false : true),
                        'composerOpenIconic'				        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_composerOpenIconic'])) ? $_POST['ts_vcsc_extend_tinymce_composerOpenIconic'] : 0))) == 0 ? false : true),
                        'composerTypicons'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_composerTypicons'])) ? $_POST['ts_vcsc_extend_tinymce_composerTypicons'] : 0))) == 0 ? false : true),
                        'composerMonoSocial'				        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_composerMonoSocial'])) ? $_POST['ts_vcsc_extend_tinymce_composerMonoSocial'] : 0))) == 0 ? false : true),
                        'composerMaterial'					        => ((intval(((isset($_POST['ts_vcsc_extend_tinymce_composerMaterial'])) ? $_POST['ts_vcsc_extend_tinymce_composerMaterial'] : 0))) == 0 ? false : true),	
                    ),
                    // Global Translations
                    'translations'							        => array(
                        // TableSaw Text Strings
                        'tablesawStack'						        => trim($_POST['ts_vcsc_extend_settings_languageTableSawStack']),
                        'tablesawSwipe'						        => trim($_POST['ts_vcsc_extend_settings_languageTableSawSwipe']),
                        'tablesawToggle'					        => trim($_POST['ts_vcsc_extend_settings_languageTableSawToggle']),
                        'tablesawResponsive'				        => trim($_POST['ts_vcsc_extend_settings_languageTableSawResponsiveness']),
                        'tablesawColumns'					        => trim($_POST['ts_vcsc_extend_settings_languageTableSawColumns']),
                        'tablesawError'						        => trim($_POST['ts_vcsc_extend_settings_languageTableSawError']),
                        'tablesawSort'						        => trim($_POST['ts_vcsc_extend_settings_languageTableSawSort']),
                        // FooTable Text Strings
                        'footableLengthMenu'				        => trim($_POST['ts_vcsc_extend_settings_languageFootableLengthMenu']),
                        'footableLengthAll'					        => trim($_POST['ts_vcsc_extend_settings_languageFootableLengthAll']),
                        'footableCountFormat'				        => trim($_POST['ts_vcsc_extend_settings_languageFootableCountFormat']),
                        'footablePlaceholder'				        => trim($_POST['ts_vcsc_extend_settings_languageFootablePlaceholder']),
                        'footableNoResults'					        => trim($_POST['ts_vcsc_extend_settings_languageFootableNoResults']),
                        // DataTable Text Strings
                        'datatableProcessing'				        => trim($_POST['ts_vcsc_extend_settings_languageDatatableProcessing']),
                        'datatableLengthMenu'				        => trim($_POST['ts_vcsc_extend_settings_languageDatatableLengthMenu']),
                        'datatableLengthAll'				        => trim($_POST['ts_vcsc_extend_settings_languageDatatableLengthAll']),
                        'datatableInfoMain'					        => trim($_POST['ts_vcsc_extend_settings_languageDatatableInfoMain']),
                        'datatableInfoEmpty'				        => trim($_POST['ts_vcsc_extend_settings_languageDatatableInfoEmpty']),
                        'datatableInfoFiltered'				        => trim($_POST['ts_vcsc_extend_settings_languageDatatableInfoFiltered']),
                        'datatableSearch'					        => trim($_POST['ts_vcsc_extend_settings_languageDatatableSearch']),
                        'datatableFilter'					        => trim($_POST['ts_vcsc_extend_settings_languageDatatableFilter']),
                        'datatablePlaceholder'				        => trim($_POST['ts_vcsc_extend_settings_languageDatatablePlaceholder']),
                        'datatableZeroRecords'				        => trim($_POST['ts_vcsc_extend_settings_languageDatatableZeroRecords']),
                        'datatableFirst'					        => trim($_POST['ts_vcsc_extend_settings_languageDatatableFirst']),
                        'datatablePrevious'					        => trim($_POST['ts_vcsc_extend_settings_languageDatatablePrevious']),
                        'datatableNext'						        => trim($_POST['ts_vcsc_extend_settings_languageDatatableNext']),
                        'datatableLast'						        => trim($_POST['ts_vcsc_extend_settings_languageDatatableLast']),
                        'datatablePrint'					        => trim($_POST['ts_vcsc_extend_settings_languageDatatablePrint']),
                        'datatablePDF'						        => trim($_POST['ts_vcsc_extend_settings_languageDatatablePDF']),
                        'datatableExcel'					        => trim($_POST['ts_vcsc_extend_settings_languageDatatableExcel']),
                        'datatableCSV'						        => trim($_POST['ts_vcsc_extend_settings_languageDatatableCSV']),
                        'datatableCopy'						        => trim($_POST['ts_vcsc_extend_settings_languageDatatableCopy']),
                    ),
                );                
                update_option("ts_tablesplus_extend_settings_globals", $TS_TablesWP_Settings_UserDefined);
				// AJAX Return Message
                $form_response['success']					        = $error_pass;
                $form_response['settings']					        = $_POST;
				if ($error_pass) {
					$form_response['utilizeajax']                   = ((intval(((isset($_POST['ts_vcsc_extend_settings_defaultUtilizeAJAX'])) ? $_POST['ts_vcsc_extend_settings_defaultUtilizeAJAX'] : 0))) == 0 ? false : true);
				} else {
                    $form_response['utilizeajax']                   = false;
                }
                wp_send_json($form_response);
                Exit();
            }
		}
	}
	if (class_exists('TS_TablesWP_Class_Settings')) {
		$TS_TablesWP_Class_Settings = new TS_TablesWP_Class_Settings;
	}
?>